#[doc = "Register `R8_ETH_ESTAT` reader"]
pub struct R(crate::R<R8_ETH_ESTAT_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_ETH_ESTAT_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_ETH_ESTAT_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_ETH_ESTAT_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Field `RB_ETH_ESTAT_TXABRT` reader - soso"]
pub type RB_ETH_ESTAT_TXABRT_R = crate::BitReader<bool>;
#[doc = "Field `RB_ETH_ESTAT_RXBUSY` reader - soso"]
pub type RB_ETH_ESTAT_RXBUSY_R = crate::BitReader<bool>;
#[doc = "Field `RB_ETH_ESTAT_RXMORE` reader - soso"]
pub type RB_ETH_ESTAT_RXMORE_R = crate::BitReader<bool>;
#[doc = "Field `RB_ETH_ESTAT_RXNIBBLE` reader - soso"]
pub type RB_ETH_ESTAT_RXNIBBLE_R = crate::BitReader<bool>;
#[doc = "Field `RB_ETH_ESTAT_RXCRCER` reader - soso"]
pub type RB_ETH_ESTAT_RXCRCER_R = crate::BitReader<bool>;
#[doc = "Field `RB_ETH_ESTAT_BUFER` reader - soso"]
pub type RB_ETH_ESTAT_BUFER_R = crate::BitReader<bool>;
#[doc = "Field `RB_ETH_ESTAT_INT` reader - soso"]
pub type RB_ETH_ESTAT_INT_R = crate::BitReader<bool>;
impl R {
    #[doc = "Bit 1 - soso"]
    #[inline(always)]
    pub fn rb_eth_estat_txabrt(&self) -> RB_ETH_ESTAT_TXABRT_R {
        RB_ETH_ESTAT_TXABRT_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - soso"]
    #[inline(always)]
    pub fn rb_eth_estat_rxbusy(&self) -> RB_ETH_ESTAT_RXBUSY_R {
        RB_ETH_ESTAT_RXBUSY_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - soso"]
    #[inline(always)]
    pub fn rb_eth_estat_rxmore(&self) -> RB_ETH_ESTAT_RXMORE_R {
        RB_ETH_ESTAT_RXMORE_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - soso"]
    #[inline(always)]
    pub fn rb_eth_estat_rxnibble(&self) -> RB_ETH_ESTAT_RXNIBBLE_R {
        RB_ETH_ESTAT_RXNIBBLE_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - soso"]
    #[inline(always)]
    pub fn rb_eth_estat_rxcrcer(&self) -> RB_ETH_ESTAT_RXCRCER_R {
        RB_ETH_ESTAT_RXCRCER_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 6 - soso"]
    #[inline(always)]
    pub fn rb_eth_estat_bufer(&self) -> RB_ETH_ESTAT_BUFER_R {
        RB_ETH_ESTAT_BUFER_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - soso"]
    #[inline(always)]
    pub fn rb_eth_estat_int(&self) -> RB_ETH_ESTAT_INT_R {
        RB_ETH_ESTAT_INT_R::new(((self.bits >> 7) & 1) != 0)
    }
}
#[doc = "soso\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_eth_estat](index.html) module"]
pub struct R8_ETH_ESTAT_SPEC;
impl crate::RegisterSpec for R8_ETH_ESTAT_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_eth_estat::R](R) reader structure"]
impl crate::Readable for R8_ETH_ESTAT_SPEC {
    type Reader = R;
}
#[doc = "`reset()` method sets R8_ETH_ESTAT to value 0"]
impl crate::Resettable for R8_ETH_ESTAT_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
