#[doc = "Register `R8_PWM_POLAR` reader"]
pub struct R(crate::R<R8_PWM_POLAR_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_PWM_POLAR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_PWM_POLAR_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_PWM_POLAR_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_PWM_POLAR` writer"]
pub struct W(crate::W<R8_PWM_POLAR_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_PWM_POLAR_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_PWM_POLAR_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_PWM_POLAR_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_PWM4_POLAR` reader - RW, PWM4 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM4_POLAR_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM4_POLAR` writer - RW, PWM4 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM4_POLAR_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_PWM_POLAR_SPEC, bool, O>;
#[doc = "Field `RB_PWM5_POLAR` reader - RW, PWM5 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM5_POLAR_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM5_POLAR` writer - RW, PWM5 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM5_POLAR_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_PWM_POLAR_SPEC, bool, O>;
#[doc = "Field `RB_PWM6_POLAR` reader - RW, PWM6 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM6_POLAR_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM6_POLAR` writer - RW, PWM6 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM6_POLAR_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_PWM_POLAR_SPEC, bool, O>;
#[doc = "Field `RB_PWM7_POLAR` reader - RW, PWM7 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM7_POLAR_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM7_POLAR` writer - RW, PWM7 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM7_POLAR_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_PWM_POLAR_SPEC, bool, O>;
#[doc = "Field `RB_PWM8_POLAR` reader - RW, PWM8 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM8_POLAR_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM8_POLAR` writer - RW, PWM8 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM8_POLAR_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_PWM_POLAR_SPEC, bool, O>;
#[doc = "Field `RB_PWM9_POLAR` reader - RW, PWM9 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM9_POLAR_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM9_POLAR` writer - RW, PWM9 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM9_POLAR_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_PWM_POLAR_SPEC, bool, O>;
#[doc = "Field `RB_PWM10_POLAR` reader - RW, PWM10 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM10_POLAR_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM10_POLAR` writer - RW, PWM10 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM10_POLAR_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_PWM_POLAR_SPEC, bool, O>;
#[doc = "Field `RB_PWM11_POLAR` reader - RW, PWM11 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM11_POLAR_R = crate::BitReader<bool>;
#[doc = "Field `RB_PWM11_POLAR` writer - RW, PWM11 output polarity: 0=default low and high action, 1=default high and low action"]
pub type RB_PWM11_POLAR_W<'a, const O: u8> = crate::BitWriter<'a, u8, R8_PWM_POLAR_SPEC, bool, O>;
impl R {
    #[doc = "Bit 0 - RW, PWM4 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    pub fn rb_pwm4_polar(&self) -> RB_PWM4_POLAR_R {
        RB_PWM4_POLAR_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - RW, PWM5 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    pub fn rb_pwm5_polar(&self) -> RB_PWM5_POLAR_R {
        RB_PWM5_POLAR_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - RW, PWM6 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    pub fn rb_pwm6_polar(&self) -> RB_PWM6_POLAR_R {
        RB_PWM6_POLAR_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - RW, PWM7 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    pub fn rb_pwm7_polar(&self) -> RB_PWM7_POLAR_R {
        RB_PWM7_POLAR_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - RW, PWM8 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    pub fn rb_pwm8_polar(&self) -> RB_PWM8_POLAR_R {
        RB_PWM8_POLAR_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - RW, PWM9 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    pub fn rb_pwm9_polar(&self) -> RB_PWM9_POLAR_R {
        RB_PWM9_POLAR_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 6 - RW, PWM10 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    pub fn rb_pwm10_polar(&self) -> RB_PWM10_POLAR_R {
        RB_PWM10_POLAR_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - RW, PWM11 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    pub fn rb_pwm11_polar(&self) -> RB_PWM11_POLAR_R {
        RB_PWM11_POLAR_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - RW, PWM4 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm4_polar(&mut self) -> RB_PWM4_POLAR_W<0> {
        RB_PWM4_POLAR_W::new(self)
    }
    #[doc = "Bit 1 - RW, PWM5 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm5_polar(&mut self) -> RB_PWM5_POLAR_W<1> {
        RB_PWM5_POLAR_W::new(self)
    }
    #[doc = "Bit 2 - RW, PWM6 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm6_polar(&mut self) -> RB_PWM6_POLAR_W<2> {
        RB_PWM6_POLAR_W::new(self)
    }
    #[doc = "Bit 3 - RW, PWM7 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm7_polar(&mut self) -> RB_PWM7_POLAR_W<3> {
        RB_PWM7_POLAR_W::new(self)
    }
    #[doc = "Bit 4 - RW, PWM8 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm8_polar(&mut self) -> RB_PWM8_POLAR_W<4> {
        RB_PWM8_POLAR_W::new(self)
    }
    #[doc = "Bit 5 - RW, PWM9 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm9_polar(&mut self) -> RB_PWM9_POLAR_W<5> {
        RB_PWM9_POLAR_W::new(self)
    }
    #[doc = "Bit 6 - RW, PWM10 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm10_polar(&mut self) -> RB_PWM10_POLAR_W<6> {
        RB_PWM10_POLAR_W::new(self)
    }
    #[doc = "Bit 7 - RW, PWM11 output polarity: 0=default low and high action, 1=default high and low action"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pwm11_polar(&mut self) -> RB_PWM11_POLAR_W<7> {
        RB_PWM11_POLAR_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, PWM output polarity control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_pwm_polar](index.html) module"]
pub struct R8_PWM_POLAR_SPEC;
impl crate::RegisterSpec for R8_PWM_POLAR_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_pwm_polar::R](R) reader structure"]
impl crate::Readable for R8_PWM_POLAR_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_pwm_polar::W](W) writer structure"]
impl crate::Writable for R8_PWM_POLAR_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_PWM_POLAR to value 0"]
impl crate::Resettable for R8_PWM_POLAR_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
