#[doc = "Register `R16_PIN_ALTERNATE` reader"]
pub struct R(crate::R<R16_PIN_ALTERNATE_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R16_PIN_ALTERNATE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R16_PIN_ALTERNATE_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R16_PIN_ALTERNATE_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R16_PIN_ALTERNATE` writer"]
pub struct W(crate::W<R16_PIN_ALTERNATE_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R16_PIN_ALTERNATE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R16_PIN_ALTERNATE_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R16_PIN_ALTERNATE_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_PIN_TMR0` reader - RW, TMR0 alternate pin enable: 0=TMR0/PWM0/CAP0 on PA\\[3\\], 1=TMR0_/PWM0_/CAP0_ on PB\\[19\\]"]
pub type RB_PIN_TMR0_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_TMR0` writer - RW, TMR0 alternate pin enable: 0=TMR0/PWM0/CAP0 on PA\\[3\\], 1=TMR0_/PWM0_/CAP0_ on PB\\[19\\]"]
pub type RB_PIN_TMR0_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ALTERNATE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_TMR1` reader - RW, TMR1 alternate pin enable: 0=TMR1/PWM1/CAP1 on PA\\[10\\], 1=TMR1_/PWM1_/CAP1_ on PB\\[10\\]"]
pub type RB_PIN_TMR1_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_TMR1` writer - RW, TMR1 alternate pin enable: 0=TMR1/PWM1/CAP1 on PA\\[10\\], 1=TMR1_/PWM1_/CAP1_ on PB\\[10\\]"]
pub type RB_PIN_TMR1_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ALTERNATE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_TMR2` reader - RW, TMR2 alternate pin enable: 0=TMR2/PWM2/CAP2 on PA\\[11\\], 1=TMR2_/PWM2_/CAP2_ on PB\\[11\\]"]
pub type RB_PIN_TMR2_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_TMR2` writer - RW, TMR2 alternate pin enable: 0=TMR2/PWM2/CAP2 on PA\\[11\\], 1=TMR2_/PWM2_/CAP2_ on PB\\[11\\]"]
pub type RB_PIN_TMR2_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ALTERNATE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_TMR3` reader - RW, TMR3 alternate pin enable: 0=TMR3/PWM3/CAP3 on PA\\[2\\], 1=TMR3_/PWM3_/CAP3_ on PB\\[18\\]"]
pub type RB_PIN_TMR3_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_TMR3` writer - RW, TMR3 alternate pin enable: 0=TMR3/PWM3/CAP3 on PA\\[2\\], 1=TMR3_/PWM3_/CAP3_ on PB\\[18\\]"]
pub type RB_PIN_TMR3_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ALTERNATE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_UART0` reader - RW, RXD0/TXD0 alternate pin enable: 0=RXD0/TXD0 on PB\\[4\\]/PB\\[7\\], 1=RXD0_/TXD0_ on PA\\[15\\]/PA\\[14\\]"]
pub type RB_PIN_UART0_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_UART0` writer - RW, RXD0/TXD0 alternate pin enable: 0=RXD0/TXD0 on PB\\[4\\]/PB\\[7\\], 1=RXD0_/TXD0_ on PA\\[15\\]/PA\\[14\\]"]
pub type RB_PIN_UART0_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ALTERNATE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_UART1` reader - RW, RXD1/TXD1 alternate pin enable: 0=RXD1/TXD1 on PA\\[8\\]/PA\\[9\\], 1=RXD1_/TXD1_ on PB\\[8\\]/PB\\[9\\]"]
pub type RB_PIN_UART1_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_UART1` writer - RW, RXD1/TXD1 alternate pin enable: 0=RXD1/TXD1 on PA\\[8\\]/PA\\[9\\], 1=RXD1_/TXD1_ on PB\\[8\\]/PB\\[9\\]"]
pub type RB_PIN_UART1_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ALTERNATE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_UART2` reader - RW, RXD2/TXD2 alternate pin enable: 0=RXD2/TXD2 on PA\\[6\\]/PA\\[7\\], 1=RXD2_/TXD2_ on PB\\[22\\]/PB\\[23\\]"]
pub type RB_PIN_UART2_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_UART2` writer - RW, RXD2/TXD2 alternate pin enable: 0=RXD2/TXD2 on PA\\[6\\]/PA\\[7\\], 1=RXD2_/TXD2_ on PB\\[22\\]/PB\\[23\\]"]
pub type RB_PIN_UART2_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ALTERNATE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_UART3` reader - RW, RXD3/TXD3 alternate pin enable: 0=RXD3/TXD3 on PA\\[4\\]/PA\\[5\\], 1=RXD3_/TXD3_ on PB\\[20\\]/PB\\[21\\]"]
pub type RB_PIN_UART3_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_UART3` writer - RW, RXD3/TXD3 alternate pin enable: 0=RXD3/TXD3 on PA\\[4\\]/PA\\[5\\], 1=RXD3_/TXD3_ on PB\\[20\\]/PB\\[21\\]"]
pub type RB_PIN_UART3_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ALTERNATE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_SPI0` reader - RW, SCS/SCK0/MOSI/MISO alternate pin enable: 0=SCS/SCK0/MOSI/MISO on PA\\[12\\]/PA\\[13\\]/PA\\[14\\]/PA\\[15\\], 1=SCS_/SCK0_/MOSI_/MISO_ on PB\\[12\\]/PB\\[13\\]/PB\\[14\\]/PB\\[15\\]"]
pub type RB_PIN_SPI0_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_SPI0` writer - RW, SCS/SCK0/MOSI/MISO alternate pin enable: 0=SCS/SCK0/MOSI/MISO on PA\\[12\\]/PA\\[13\\]/PA\\[14\\]/PA\\[15\\], 1=SCS_/SCK0_/MOSI_/MISO_ on PB\\[12\\]/PB\\[13\\]/PB\\[14\\]/PB\\[15\\]"]
pub type RB_PIN_SPI0_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ALTERNATE_SPEC, bool, O>;
impl R {
    #[doc = "Bit 0 - RW, TMR0 alternate pin enable: 0=TMR0/PWM0/CAP0 on PA\\[3\\], 1=TMR0_/PWM0_/CAP0_ on PB\\[19\\]"]
    #[inline(always)]
    pub fn rb_pin_tmr0(&self) -> RB_PIN_TMR0_R {
        RB_PIN_TMR0_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - RW, TMR1 alternate pin enable: 0=TMR1/PWM1/CAP1 on PA\\[10\\], 1=TMR1_/PWM1_/CAP1_ on PB\\[10\\]"]
    #[inline(always)]
    pub fn rb_pin_tmr1(&self) -> RB_PIN_TMR1_R {
        RB_PIN_TMR1_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - RW, TMR2 alternate pin enable: 0=TMR2/PWM2/CAP2 on PA\\[11\\], 1=TMR2_/PWM2_/CAP2_ on PB\\[11\\]"]
    #[inline(always)]
    pub fn rb_pin_tmr2(&self) -> RB_PIN_TMR2_R {
        RB_PIN_TMR2_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - RW, TMR3 alternate pin enable: 0=TMR3/PWM3/CAP3 on PA\\[2\\], 1=TMR3_/PWM3_/CAP3_ on PB\\[18\\]"]
    #[inline(always)]
    pub fn rb_pin_tmr3(&self) -> RB_PIN_TMR3_R {
        RB_PIN_TMR3_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - RW, RXD0/TXD0 alternate pin enable: 0=RXD0/TXD0 on PB\\[4\\]/PB\\[7\\], 1=RXD0_/TXD0_ on PA\\[15\\]/PA\\[14\\]"]
    #[inline(always)]
    pub fn rb_pin_uart0(&self) -> RB_PIN_UART0_R {
        RB_PIN_UART0_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - RW, RXD1/TXD1 alternate pin enable: 0=RXD1/TXD1 on PA\\[8\\]/PA\\[9\\], 1=RXD1_/TXD1_ on PB\\[8\\]/PB\\[9\\]"]
    #[inline(always)]
    pub fn rb_pin_uart1(&self) -> RB_PIN_UART1_R {
        RB_PIN_UART1_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 6 - RW, RXD2/TXD2 alternate pin enable: 0=RXD2/TXD2 on PA\\[6\\]/PA\\[7\\], 1=RXD2_/TXD2_ on PB\\[22\\]/PB\\[23\\]"]
    #[inline(always)]
    pub fn rb_pin_uart2(&self) -> RB_PIN_UART2_R {
        RB_PIN_UART2_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - RW, RXD3/TXD3 alternate pin enable: 0=RXD3/TXD3 on PA\\[4\\]/PA\\[5\\], 1=RXD3_/TXD3_ on PB\\[20\\]/PB\\[21\\]"]
    #[inline(always)]
    pub fn rb_pin_uart3(&self) -> RB_PIN_UART3_R {
        RB_PIN_UART3_R::new(((self.bits >> 7) & 1) != 0)
    }
    #[doc = "Bit 8 - RW, SCS/SCK0/MOSI/MISO alternate pin enable: 0=SCS/SCK0/MOSI/MISO on PA\\[12\\]/PA\\[13\\]/PA\\[14\\]/PA\\[15\\], 1=SCS_/SCK0_/MOSI_/MISO_ on PB\\[12\\]/PB\\[13\\]/PB\\[14\\]/PB\\[15\\]"]
    #[inline(always)]
    pub fn rb_pin_spi0(&self) -> RB_PIN_SPI0_R {
        RB_PIN_SPI0_R::new(((self.bits >> 8) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - RW, TMR0 alternate pin enable: 0=TMR0/PWM0/CAP0 on PA\\[3\\], 1=TMR0_/PWM0_/CAP0_ on PB\\[19\\]"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_tmr0(&mut self) -> RB_PIN_TMR0_W<0> {
        RB_PIN_TMR0_W::new(self)
    }
    #[doc = "Bit 1 - RW, TMR1 alternate pin enable: 0=TMR1/PWM1/CAP1 on PA\\[10\\], 1=TMR1_/PWM1_/CAP1_ on PB\\[10\\]"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_tmr1(&mut self) -> RB_PIN_TMR1_W<1> {
        RB_PIN_TMR1_W::new(self)
    }
    #[doc = "Bit 2 - RW, TMR2 alternate pin enable: 0=TMR2/PWM2/CAP2 on PA\\[11\\], 1=TMR2_/PWM2_/CAP2_ on PB\\[11\\]"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_tmr2(&mut self) -> RB_PIN_TMR2_W<2> {
        RB_PIN_TMR2_W::new(self)
    }
    #[doc = "Bit 3 - RW, TMR3 alternate pin enable: 0=TMR3/PWM3/CAP3 on PA\\[2\\], 1=TMR3_/PWM3_/CAP3_ on PB\\[18\\]"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_tmr3(&mut self) -> RB_PIN_TMR3_W<3> {
        RB_PIN_TMR3_W::new(self)
    }
    #[doc = "Bit 4 - RW, RXD0/TXD0 alternate pin enable: 0=RXD0/TXD0 on PB\\[4\\]/PB\\[7\\], 1=RXD0_/TXD0_ on PA\\[15\\]/PA\\[14\\]"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_uart0(&mut self) -> RB_PIN_UART0_W<4> {
        RB_PIN_UART0_W::new(self)
    }
    #[doc = "Bit 5 - RW, RXD1/TXD1 alternate pin enable: 0=RXD1/TXD1 on PA\\[8\\]/PA\\[9\\], 1=RXD1_/TXD1_ on PB\\[8\\]/PB\\[9\\]"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_uart1(&mut self) -> RB_PIN_UART1_W<5> {
        RB_PIN_UART1_W::new(self)
    }
    #[doc = "Bit 6 - RW, RXD2/TXD2 alternate pin enable: 0=RXD2/TXD2 on PA\\[6\\]/PA\\[7\\], 1=RXD2_/TXD2_ on PB\\[22\\]/PB\\[23\\]"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_uart2(&mut self) -> RB_PIN_UART2_W<6> {
        RB_PIN_UART2_W::new(self)
    }
    #[doc = "Bit 7 - RW, RXD3/TXD3 alternate pin enable: 0=RXD3/TXD3 on PA\\[4\\]/PA\\[5\\], 1=RXD3_/TXD3_ on PB\\[20\\]/PB\\[21\\]"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_uart3(&mut self) -> RB_PIN_UART3_W<7> {
        RB_PIN_UART3_W::new(self)
    }
    #[doc = "Bit 8 - RW, SCS/SCK0/MOSI/MISO alternate pin enable: 0=SCS/SCK0/MOSI/MISO on PA\\[12\\]/PA\\[13\\]/PA\\[14\\]/PA\\[15\\], 1=SCS_/SCK0_/MOSI_/MISO_ on PB\\[12\\]/PB\\[13\\]/PB\\[14\\]/PB\\[15\\]"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_spi0(&mut self) -> RB_PIN_SPI0_W<8> {
        RB_PIN_SPI0_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, function pin alternate configuration\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r16_pin_alternate](index.html) module"]
pub struct R16_PIN_ALTERNATE_SPEC;
impl crate::RegisterSpec for R16_PIN_ALTERNATE_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [r16_pin_alternate::R](R) reader structure"]
impl crate::Readable for R16_PIN_ALTERNATE_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r16_pin_alternate::W](W) writer structure"]
impl crate::Writable for R16_PIN_ALTERNATE_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R16_PIN_ALTERNATE to value 0"]
impl crate::Resettable for R16_PIN_ALTERNATE_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
