#[doc = "Register `R16_PIN_ANALOG_IE` reader"]
pub struct R(crate::R<R16_PIN_ANALOG_IE_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R16_PIN_ANALOG_IE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R16_PIN_ANALOG_IE_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R16_PIN_ANALOG_IE_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R16_PIN_ANALOG_IE` writer"]
pub struct W(crate::W<R16_PIN_ANALOG_IE_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R16_PIN_ANALOG_IE_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R16_PIN_ANALOG_IE_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R16_PIN_ANALOG_IE_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_PIN_SEG0_3_IE` reader - RW, LCD segment 0~3 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG0_3_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_SEG0_3_IE` writer - RW, LCD segment 0~3 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG0_3_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_SEG4_7_IE` reader - RW, LCD segment 4~7 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG4_7_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_SEG4_7_IE` writer - RW, LCD segment 4~7 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG4_7_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_SEG8_11_IE` reader - RW, LCD segment 8~11 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG8_11_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_SEG8_11_IE` writer - RW, LCD segment 8~11 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG8_11_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_SEG12_15_IE` reader - RW, LCD segment 12~15 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG12_15_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_SEG12_15_IE` writer - RW, LCD segment 12~15 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG12_15_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_SEG16_19_IE` reader - RW, LCD segment 16~19 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG16_19_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_SEG16_19_IE` writer - RW, LCD segment 16~19 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG16_19_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_SEG20_23_IE` reader - RW, LCD segment 20~23 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG20_23_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_SEG20_23_IE` writer - RW, LCD segment 20~23 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_SEG20_23_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_ETH_IE` reader - RW, ETH analog I/O enable and digital input disable: 0=analog I/O disable and digital input enable, 1=analog I/O enable and digital input disable"]
pub type RB_PIN_ETH_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_ETH_IE` writer - RW, ETH analog I/O enable and digital input disable: 0=analog I/O disable and digital input enable, 1=analog I/O enable and digital input disable"]
pub type RB_PIN_ETH_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_USB_IE` reader - RW, USB analog I/O enable: 0=analog I/O disable, 1=analog I/O enable"]
pub type RB_PIN_USB_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_USB_IE` writer - RW, USB analog I/O enable: 0=analog I/O disable, 1=analog I/O enable"]
pub type RB_PIN_USB_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_ADC8_9_IE` reader - RW, ADC/TouchKey channel 9/8 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC8_9_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_ADC8_9_IE` writer - RW, ADC/TouchKey channel 9/8 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC8_9_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_ADC6_7_IE` reader - RW, ADC/TouchKey channel 7/6 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC6_7_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_ADC6_7_IE` writer - RW, ADC/TouchKey channel 7/6 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC6_7_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_ADC0_1_IE` reader - RW, ADC/TouchKey channel 0/1 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC0_1_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_ADC0_1_IE` writer - RW, ADC/TouchKey channel 0/1 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC0_1_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_ADC10_11_IE` reader - RW, ADC/TouchKey channel 10/11 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC10_11_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_ADC10_11_IE` writer - RW, ADC/TouchKey channel 10/11 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC10_11_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_ADC12_13_IE` reader - RW, ADC/TouchKey channel 12/13 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC12_13_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_ADC12_13_IE` writer - RW, ADC/TouchKey channel 12/13 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC12_13_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_XT32K_IE` reader - RW, external 32KHz oscillator digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_XT32K_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_XT32K_IE` writer - RW, external 32KHz oscillator digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_XT32K_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_ADC2_3_IE` reader - RW, ADC/TouchKey channel 2/3 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC2_3_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_ADC2_3_IE` writer - RW, ADC/TouchKey channel 2/3 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC2_3_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
#[doc = "Field `RB_PIN_ADC4_5_IE` reader - RW, ADC/TouchKey channel 4/5 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC4_5_IE_R = crate::BitReader<bool>;
#[doc = "Field `RB_PIN_ADC4_5_IE` writer - RW, ADC/TouchKey channel 4/5 digital input disable: 0=digital input enable, 1=digital input disable"]
pub type RB_PIN_ADC4_5_IE_W<'a, const O: u8> =
    crate::BitWriter<'a, u16, R16_PIN_ANALOG_IE_SPEC, bool, O>;
impl R {
    #[doc = "Bit 0 - RW, LCD segment 0~3 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_seg0_3_ie(&self) -> RB_PIN_SEG0_3_IE_R {
        RB_PIN_SEG0_3_IE_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - RW, LCD segment 4~7 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_seg4_7_ie(&self) -> RB_PIN_SEG4_7_IE_R {
        RB_PIN_SEG4_7_IE_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - RW, LCD segment 8~11 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_seg8_11_ie(&self) -> RB_PIN_SEG8_11_IE_R {
        RB_PIN_SEG8_11_IE_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - RW, LCD segment 12~15 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_seg12_15_ie(&self) -> RB_PIN_SEG12_15_IE_R {
        RB_PIN_SEG12_15_IE_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - RW, LCD segment 16~19 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_seg16_19_ie(&self) -> RB_PIN_SEG16_19_IE_R {
        RB_PIN_SEG16_19_IE_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - RW, LCD segment 20~23 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_seg20_23_ie(&self) -> RB_PIN_SEG20_23_IE_R {
        RB_PIN_SEG20_23_IE_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 6 - RW, ETH analog I/O enable and digital input disable: 0=analog I/O disable and digital input enable, 1=analog I/O enable and digital input disable"]
    #[inline(always)]
    pub fn rb_pin_eth_ie(&self) -> RB_PIN_ETH_IE_R {
        RB_PIN_ETH_IE_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - RW, USB analog I/O enable: 0=analog I/O disable, 1=analog I/O enable"]
    #[inline(always)]
    pub fn rb_pin_usb_ie(&self) -> RB_PIN_USB_IE_R {
        RB_PIN_USB_IE_R::new(((self.bits >> 7) & 1) != 0)
    }
    #[doc = "Bit 8 - RW, ADC/TouchKey channel 9/8 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_adc8_9_ie(&self) -> RB_PIN_ADC8_9_IE_R {
        RB_PIN_ADC8_9_IE_R::new(((self.bits >> 8) & 1) != 0)
    }
    #[doc = "Bit 9 - RW, ADC/TouchKey channel 7/6 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_adc6_7_ie(&self) -> RB_PIN_ADC6_7_IE_R {
        RB_PIN_ADC6_7_IE_R::new(((self.bits >> 9) & 1) != 0)
    }
    #[doc = "Bit 10 - RW, ADC/TouchKey channel 0/1 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_adc0_1_ie(&self) -> RB_PIN_ADC0_1_IE_R {
        RB_PIN_ADC0_1_IE_R::new(((self.bits >> 10) & 1) != 0)
    }
    #[doc = "Bit 11 - RW, ADC/TouchKey channel 10/11 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_adc10_11_ie(&self) -> RB_PIN_ADC10_11_IE_R {
        RB_PIN_ADC10_11_IE_R::new(((self.bits >> 11) & 1) != 0)
    }
    #[doc = "Bit 12 - RW, ADC/TouchKey channel 12/13 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_adc12_13_ie(&self) -> RB_PIN_ADC12_13_IE_R {
        RB_PIN_ADC12_13_IE_R::new(((self.bits >> 12) & 1) != 0)
    }
    #[doc = "Bit 13 - RW, external 32KHz oscillator digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_xt32k_ie(&self) -> RB_PIN_XT32K_IE_R {
        RB_PIN_XT32K_IE_R::new(((self.bits >> 13) & 1) != 0)
    }
    #[doc = "Bit 14 - RW, ADC/TouchKey channel 2/3 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_adc2_3_ie(&self) -> RB_PIN_ADC2_3_IE_R {
        RB_PIN_ADC2_3_IE_R::new(((self.bits >> 14) & 1) != 0)
    }
    #[doc = "Bit 15 - RW, ADC/TouchKey channel 4/5 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    pub fn rb_pin_adc4_5_ie(&self) -> RB_PIN_ADC4_5_IE_R {
        RB_PIN_ADC4_5_IE_R::new(((self.bits >> 15) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - RW, LCD segment 0~3 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_seg0_3_ie(&mut self) -> RB_PIN_SEG0_3_IE_W<0> {
        RB_PIN_SEG0_3_IE_W::new(self)
    }
    #[doc = "Bit 1 - RW, LCD segment 4~7 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_seg4_7_ie(&mut self) -> RB_PIN_SEG4_7_IE_W<1> {
        RB_PIN_SEG4_7_IE_W::new(self)
    }
    #[doc = "Bit 2 - RW, LCD segment 8~11 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_seg8_11_ie(&mut self) -> RB_PIN_SEG8_11_IE_W<2> {
        RB_PIN_SEG8_11_IE_W::new(self)
    }
    #[doc = "Bit 3 - RW, LCD segment 12~15 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_seg12_15_ie(&mut self) -> RB_PIN_SEG12_15_IE_W<3> {
        RB_PIN_SEG12_15_IE_W::new(self)
    }
    #[doc = "Bit 4 - RW, LCD segment 16~19 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_seg16_19_ie(&mut self) -> RB_PIN_SEG16_19_IE_W<4> {
        RB_PIN_SEG16_19_IE_W::new(self)
    }
    #[doc = "Bit 5 - RW, LCD segment 20~23 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_seg20_23_ie(&mut self) -> RB_PIN_SEG20_23_IE_W<5> {
        RB_PIN_SEG20_23_IE_W::new(self)
    }
    #[doc = "Bit 6 - RW, ETH analog I/O enable and digital input disable: 0=analog I/O disable and digital input enable, 1=analog I/O enable and digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_eth_ie(&mut self) -> RB_PIN_ETH_IE_W<6> {
        RB_PIN_ETH_IE_W::new(self)
    }
    #[doc = "Bit 7 - RW, USB analog I/O enable: 0=analog I/O disable, 1=analog I/O enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_usb_ie(&mut self) -> RB_PIN_USB_IE_W<7> {
        RB_PIN_USB_IE_W::new(self)
    }
    #[doc = "Bit 8 - RW, ADC/TouchKey channel 9/8 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_adc8_9_ie(&mut self) -> RB_PIN_ADC8_9_IE_W<8> {
        RB_PIN_ADC8_9_IE_W::new(self)
    }
    #[doc = "Bit 9 - RW, ADC/TouchKey channel 7/6 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_adc6_7_ie(&mut self) -> RB_PIN_ADC6_7_IE_W<9> {
        RB_PIN_ADC6_7_IE_W::new(self)
    }
    #[doc = "Bit 10 - RW, ADC/TouchKey channel 0/1 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_adc0_1_ie(&mut self) -> RB_PIN_ADC0_1_IE_W<10> {
        RB_PIN_ADC0_1_IE_W::new(self)
    }
    #[doc = "Bit 11 - RW, ADC/TouchKey channel 10/11 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_adc10_11_ie(&mut self) -> RB_PIN_ADC10_11_IE_W<11> {
        RB_PIN_ADC10_11_IE_W::new(self)
    }
    #[doc = "Bit 12 - RW, ADC/TouchKey channel 12/13 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_adc12_13_ie(&mut self) -> RB_PIN_ADC12_13_IE_W<12> {
        RB_PIN_ADC12_13_IE_W::new(self)
    }
    #[doc = "Bit 13 - RW, external 32KHz oscillator digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_xt32k_ie(&mut self) -> RB_PIN_XT32K_IE_W<13> {
        RB_PIN_XT32K_IE_W::new(self)
    }
    #[doc = "Bit 14 - RW, ADC/TouchKey channel 2/3 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_adc2_3_ie(&mut self) -> RB_PIN_ADC2_3_IE_W<14> {
        RB_PIN_ADC2_3_IE_W::new(self)
    }
    #[doc = "Bit 15 - RW, ADC/TouchKey channel 4/5 digital input disable: 0=digital input enable, 1=digital input disable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_pin_adc4_5_ie(&mut self) -> RB_PIN_ADC4_5_IE_W<15> {
        RB_PIN_ADC4_5_IE_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, analog pin enable and digital input disable\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r16_pin_analog_ie](index.html) module"]
pub struct R16_PIN_ANALOG_IE_SPEC;
impl crate::RegisterSpec for R16_PIN_ANALOG_IE_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [r16_pin_analog_ie::R](R) reader structure"]
impl crate::Readable for R16_PIN_ANALOG_IE_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r16_pin_analog_ie::W](W) writer structure"]
impl crate::Writable for R16_PIN_ANALOG_IE_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R16_PIN_ANALOG_IE to value 0"]
impl crate::Resettable for R16_PIN_ANALOG_IE_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
