#[doc = "Register `R32_RTC_CNT_DAY` reader"]
pub struct R(crate::R<R32_RTC_CNT_DAY_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R32_RTC_CNT_DAY_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R32_RTC_CNT_DAY_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R32_RTC_CNT_DAY_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "RO, RTC count based one day, only low 14 bit\n\nThis register you can [`read`](crate::generic::Reg::read). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r32_rtc_cnt_day](index.html) module"]
pub struct R32_RTC_CNT_DAY_SPEC;
impl crate::RegisterSpec for R32_RTC_CNT_DAY_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [r32_rtc_cnt_day::R](R) reader structure"]
impl crate::Readable for R32_RTC_CNT_DAY_SPEC {
    type Reader = R;
}
#[doc = "`reset()` method sets R32_RTC_CNT_DAY to value 0"]
impl crate::Resettable for R32_RTC_CNT_DAY_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
