#[doc = "Register `R8_RTC_MODE_CTRL` reader"]
pub struct R(crate::R<R8_RTC_MODE_CTRL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_RTC_MODE_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_RTC_MODE_CTRL_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_RTC_MODE_CTRL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_RTC_MODE_CTRL` writer"]
pub struct W(crate::W<R8_RTC_MODE_CTRL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_RTC_MODE_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_RTC_MODE_CTRL_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_RTC_MODE_CTRL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_RTC_TMR_MODE` reader - RWA, RTC timer mode: 000=0.125S, 001=0.25S, 010=0.5S, 011=1S, 100=2S, 101=4S, 110=8S, 111=16S"]
pub type RB_RTC_TMR_MODE_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_RTC_TMR_MODE` writer - RWA, RTC timer mode: 000=0.125S, 001=0.25S, 010=0.5S, 011=1S, 100=2S, 101=4S, 110=8S, 111=16S"]
pub type RB_RTC_TMR_MODE_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_RTC_MODE_CTRL_SPEC, u8, u8, 3, O>;
#[doc = "Field `RB_RTC_IGNORE_B0` reader - RWA, force ignore bit0 for trigger mode: 0=compare bit0, 1=ignore bit0"]
pub type RB_RTC_IGNORE_B0_R = crate::BitReader<bool>;
#[doc = "Field `RB_RTC_IGNORE_B0` writer - RWA, force ignore bit0 for trigger mode: 0=compare bit0, 1=ignore bit0"]
pub type RB_RTC_IGNORE_B0_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_RTC_MODE_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_RTC_TMR_EN` reader - RWA, RTC timer mode enable"]
pub type RB_RTC_TMR_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_RTC_TMR_EN` writer - RWA, RTC timer mode enable"]
pub type RB_RTC_TMR_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_RTC_MODE_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_RTC_TRIG_EN` reader - RWA, RTC trigger mode enable"]
pub type RB_RTC_TRIG_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_RTC_TRIG_EN` writer - RWA, RTC trigger mode enable"]
pub type RB_RTC_TRIG_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_RTC_MODE_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_RTC_LOAD_LO` reader - RWA, set 1 to load RTC count low word R32_RTC_CNT_32K, auto clear after loaded"]
pub type RB_RTC_LOAD_LO_R = crate::BitReader<bool>;
#[doc = "Field `RB_RTC_LOAD_LO` writer - RWA, set 1 to load RTC count low word R32_RTC_CNT_32K, auto clear after loaded"]
pub type RB_RTC_LOAD_LO_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_RTC_MODE_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_RTC_LOAD_HI` reader - RWA, set 1 to load RTC count high word R32_RTC_CNT_DAY, auto clear after loaded"]
pub type RB_RTC_LOAD_HI_R = crate::BitReader<bool>;
#[doc = "Field `RB_RTC_LOAD_HI` writer - RWA, set 1 to load RTC count high word R32_RTC_CNT_DAY, auto clear after loaded"]
pub type RB_RTC_LOAD_HI_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_RTC_MODE_CTRL_SPEC, bool, O>;
impl R {
    #[doc = "Bits 0:2 - RWA, RTC timer mode: 000=0.125S, 001=0.25S, 010=0.5S, 011=1S, 100=2S, 101=4S, 110=8S, 111=16S"]
    #[inline(always)]
    pub fn rb_rtc_tmr_mode(&self) -> RB_RTC_TMR_MODE_R {
        RB_RTC_TMR_MODE_R::new(self.bits & 7)
    }
    #[doc = "Bit 3 - RWA, force ignore bit0 for trigger mode: 0=compare bit0, 1=ignore bit0"]
    #[inline(always)]
    pub fn rb_rtc_ignore_b0(&self) -> RB_RTC_IGNORE_B0_R {
        RB_RTC_IGNORE_B0_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bit 4 - RWA, RTC timer mode enable"]
    #[inline(always)]
    pub fn rb_rtc_tmr_en(&self) -> RB_RTC_TMR_EN_R {
        RB_RTC_TMR_EN_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - RWA, RTC trigger mode enable"]
    #[inline(always)]
    pub fn rb_rtc_trig_en(&self) -> RB_RTC_TRIG_EN_R {
        RB_RTC_TRIG_EN_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 6 - RWA, set 1 to load RTC count low word R32_RTC_CNT_32K, auto clear after loaded"]
    #[inline(always)]
    pub fn rb_rtc_load_lo(&self) -> RB_RTC_LOAD_LO_R {
        RB_RTC_LOAD_LO_R::new(((self.bits >> 6) & 1) != 0)
    }
    #[doc = "Bit 7 - RWA, set 1 to load RTC count high word R32_RTC_CNT_DAY, auto clear after loaded"]
    #[inline(always)]
    pub fn rb_rtc_load_hi(&self) -> RB_RTC_LOAD_HI_R {
        RB_RTC_LOAD_HI_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bits 0:2 - RWA, RTC timer mode: 000=0.125S, 001=0.25S, 010=0.5S, 011=1S, 100=2S, 101=4S, 110=8S, 111=16S"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rtc_tmr_mode(&mut self) -> RB_RTC_TMR_MODE_W<0> {
        RB_RTC_TMR_MODE_W::new(self)
    }
    #[doc = "Bit 3 - RWA, force ignore bit0 for trigger mode: 0=compare bit0, 1=ignore bit0"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rtc_ignore_b0(&mut self) -> RB_RTC_IGNORE_B0_W<3> {
        RB_RTC_IGNORE_B0_W::new(self)
    }
    #[doc = "Bit 4 - RWA, RTC timer mode enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rtc_tmr_en(&mut self) -> RB_RTC_TMR_EN_W<4> {
        RB_RTC_TMR_EN_W::new(self)
    }
    #[doc = "Bit 5 - RWA, RTC trigger mode enable"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rtc_trig_en(&mut self) -> RB_RTC_TRIG_EN_W<5> {
        RB_RTC_TRIG_EN_W::new(self)
    }
    #[doc = "Bit 6 - RWA, set 1 to load RTC count low word R32_RTC_CNT_32K, auto clear after loaded"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rtc_load_lo(&mut self) -> RB_RTC_LOAD_LO_W<6> {
        RB_RTC_LOAD_LO_W::new(self)
    }
    #[doc = "Bit 7 - RWA, set 1 to load RTC count high word R32_RTC_CNT_DAY, auto clear after loaded"]
    #[inline(always)]
    #[must_use]
    pub fn rb_rtc_load_hi(&mut self) -> RB_RTC_LOAD_HI_W<7> {
        RB_RTC_LOAD_HI_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RWA, RTC mode control, SAM\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_rtc_mode_ctrl](index.html) module"]
pub struct R8_RTC_MODE_CTRL_SPEC;
impl crate::RegisterSpec for R8_RTC_MODE_CTRL_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_rtc_mode_ctrl::R](R) reader structure"]
impl crate::Readable for R8_RTC_MODE_CTRL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_rtc_mode_ctrl::W](W) writer structure"]
impl crate::Writable for R8_RTC_MODE_CTRL_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_RTC_MODE_CTRL to value 0"]
impl crate::Resettable for R8_RTC_MODE_CTRL_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
