#[doc = "Register `R8_ETH_MACON1` reader"]
pub struct R(crate::R<R8_ETH_MACON1_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_ETH_MACON1_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_ETH_MACON1_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_ETH_MACON1_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_ETH_MACON1` writer"]
pub struct W(crate::W<R8_ETH_MACON1_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_ETH_MACON1_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_ETH_MACON1_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_ETH_MACON1_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_ETH_MACON1_MARXEN` reader - soso"]
pub type RB_ETH_MACON1_MARXEN_R = crate::BitReader<bool>;
#[doc = "Field `RB_ETH_MACON1_MARXEN` writer - soso"]
pub type RB_ETH_MACON1_MARXEN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_ETH_MACON1_SPEC, bool, O>;
#[doc = "Field `RB_ETH_MACON1_PASSALL` reader - soso"]
pub type RB_ETH_MACON1_PASSALL_R = crate::BitReader<bool>;
#[doc = "Field `RB_ETH_MACON1_PASSALL` writer - soso"]
pub type RB_ETH_MACON1_PASSALL_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_ETH_MACON1_SPEC, bool, O>;
#[doc = "Field `RB_ETH_MACON1_RXPAUS` reader - soso"]
pub type RB_ETH_MACON1_RXPAUS_R = crate::BitReader<bool>;
#[doc = "Field `RB_ETH_MACON1_RXPAUS` writer - soso"]
pub type RB_ETH_MACON1_RXPAUS_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_ETH_MACON1_SPEC, bool, O>;
#[doc = "Field `RB_ETH_MACON1_TXPAUS` reader - soso"]
pub type RB_ETH_MACON1_TXPAUS_R = crate::BitReader<bool>;
#[doc = "Field `RB_ETH_MACON1_TXPAUS` writer - soso"]
pub type RB_ETH_MACON1_TXPAUS_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_ETH_MACON1_SPEC, bool, O>;
#[doc = "Field `RB_ETH_MACON1_FCEN` reader - soso"]
pub type RB_ETH_MACON1_FCEN_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_ETH_MACON1_FCEN` writer - soso"]
pub type RB_ETH_MACON1_FCEN_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_ETH_MACON1_SPEC, u8, u8, 2, O>;
impl R {
    #[doc = "Bit 0 - soso"]
    #[inline(always)]
    pub fn rb_eth_macon1_marxen(&self) -> RB_ETH_MACON1_MARXEN_R {
        RB_ETH_MACON1_MARXEN_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - soso"]
    #[inline(always)]
    pub fn rb_eth_macon1_passall(&self) -> RB_ETH_MACON1_PASSALL_R {
        RB_ETH_MACON1_PASSALL_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - soso"]
    #[inline(always)]
    pub fn rb_eth_macon1_rxpaus(&self) -> RB_ETH_MACON1_RXPAUS_R {
        RB_ETH_MACON1_RXPAUS_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 3 - soso"]
    #[inline(always)]
    pub fn rb_eth_macon1_txpaus(&self) -> RB_ETH_MACON1_TXPAUS_R {
        RB_ETH_MACON1_TXPAUS_R::new(((self.bits >> 3) & 1) != 0)
    }
    #[doc = "Bits 4:5 - soso"]
    #[inline(always)]
    pub fn rb_eth_macon1_fcen(&self) -> RB_ETH_MACON1_FCEN_R {
        RB_ETH_MACON1_FCEN_R::new((self.bits >> 4) & 3)
    }
}
impl W {
    #[doc = "Bit 0 - soso"]
    #[inline(always)]
    #[must_use]
    pub fn rb_eth_macon1_marxen(&mut self) -> RB_ETH_MACON1_MARXEN_W<0> {
        RB_ETH_MACON1_MARXEN_W::new(self)
    }
    #[doc = "Bit 1 - soso"]
    #[inline(always)]
    #[must_use]
    pub fn rb_eth_macon1_passall(&mut self) -> RB_ETH_MACON1_PASSALL_W<1> {
        RB_ETH_MACON1_PASSALL_W::new(self)
    }
    #[doc = "Bit 2 - soso"]
    #[inline(always)]
    #[must_use]
    pub fn rb_eth_macon1_rxpaus(&mut self) -> RB_ETH_MACON1_RXPAUS_W<2> {
        RB_ETH_MACON1_RXPAUS_W::new(self)
    }
    #[doc = "Bit 3 - soso"]
    #[inline(always)]
    #[must_use]
    pub fn rb_eth_macon1_txpaus(&mut self) -> RB_ETH_MACON1_TXPAUS_W<3> {
        RB_ETH_MACON1_TXPAUS_W::new(self)
    }
    #[doc = "Bits 4:5 - soso"]
    #[inline(always)]
    #[must_use]
    pub fn rb_eth_macon1_fcen(&mut self) -> RB_ETH_MACON1_FCEN_W<4> {
        RB_ETH_MACON1_FCEN_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "soso\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_eth_macon1](index.html) module"]
pub struct R8_ETH_MACON1_SPEC;
impl crate::RegisterSpec for R8_ETH_MACON1_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_eth_macon1::R](R) reader structure"]
impl crate::Readable for R8_ETH_MACON1_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_eth_macon1::W](W) writer structure"]
impl crate::Writable for R8_ETH_MACON1_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_ETH_MACON1 to value 0"]
impl crate::Resettable for R8_ETH_MACON1_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
