#[doc = "Register `R8_ADC_CHANNEL` reader"]
pub struct R(crate::R<R8_ADC_CHANNEL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_ADC_CHANNEL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_ADC_CHANNEL_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_ADC_CHANNEL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_ADC_CHANNEL` writer"]
pub struct W(crate::W<R8_ADC_CHANNEL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_ADC_CHANNEL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_ADC_CHANNEL_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_ADC_CHANNEL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_ADC_CH_INX` reader - RW, ADC input channel index"]
pub type RB_ADC_CH_INX_R = crate::FieldReader<u8, u8>;
#[doc = "Field `RB_ADC_CH_INX` writer - RW, ADC input channel index"]
pub type RB_ADC_CH_INX_W<'a, const O: u8> =
    crate::FieldWriter<'a, u8, R8_ADC_CHANNEL_SPEC, u8, u8, 4, O>;
impl R {
    #[doc = "Bits 0:3 - RW, ADC input channel index"]
    #[inline(always)]
    pub fn rb_adc_ch_inx(&self) -> RB_ADC_CH_INX_R {
        RB_ADC_CH_INX_R::new(self.bits & 0x0f)
    }
}
impl W {
    #[doc = "Bits 0:3 - RW, ADC input channel index"]
    #[inline(always)]
    #[must_use]
    pub fn rb_adc_ch_inx(&mut self) -> RB_ADC_CH_INX_W<0> {
        RB_ADC_CH_INX_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "RW, ADC input channel selection\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_adc_channel](index.html) module"]
pub struct R8_ADC_CHANNEL_SPEC;
impl crate::RegisterSpec for R8_ADC_CHANNEL_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_adc_channel::R](R) reader structure"]
impl crate::Readable for R8_ADC_CHANNEL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_adc_channel::W](W) writer structure"]
impl crate::Writable for R8_ADC_CHANNEL_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_ADC_CHANNEL to value 0"]
impl crate::Resettable for R8_ADC_CHANNEL_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
