#[doc = "Register `R8_UDEV_CTRL__R8_UHOST_CTRL` reader"]
pub struct R(crate::R<R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl From<crate::R<R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC>> for R {
    #[inline(always)]
    fn from(reader: crate::R<R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `R8_UDEV_CTRL__R8_UHOST_CTRL` writer"]
pub struct W(crate::W<R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl From<crate::W<R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC>> for W {
    #[inline(always)]
    fn from(writer: crate::W<R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `RB_UD_PORT_EN__RB_UH_PORT_EN` reader - enable USB physical port I/O: 0=disable, 1=enable;enable USB port: 0=disable, 1=enable port, automatic disabled if USB device detached"]
pub type RB_UD_PORT_EN__RB_UH_PORT_EN_R = crate::BitReader<bool>;
#[doc = "Field `RB_UD_PORT_EN__RB_UH_PORT_EN` writer - enable USB physical port I/O: 0=disable, 1=enable;enable USB port: 0=disable, 1=enable port, automatic disabled if USB device detached"]
pub type RB_UD_PORT_EN__RB_UH_PORT_EN_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_UD_GP_BIT__RB_UH_BUS_RESET` reader - general purpose bit;control USB bus reset: 0=normal, 1=force bus reset"]
pub type RB_UD_GP_BIT__RB_UH_BUS_RESET_R = crate::BitReader<bool>;
#[doc = "Field `RB_UD_GP_BIT__RB_UH_BUS_RESET` writer - general purpose bit;control USB bus reset: 0=normal, 1=force bus reset"]
pub type RB_UD_GP_BIT__RB_UH_BUS_RESET_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_UD_LOW_SPEED__RB_UH_LOW_SPEED` reader - enable USB physical port low speed: 0=full speed, 1=low speed;enable USB port low speed: 0=full speed, 1=low speed"]
pub type RB_UD_LOW_SPEED__RB_UH_LOW_SPEED_R = crate::BitReader<bool>;
#[doc = "Field `RB_UD_LOW_SPEED__RB_UH_LOW_SPEED` writer - enable USB physical port low speed: 0=full speed, 1=low speed;enable USB port low speed: 0=full speed, 1=low speed"]
pub type RB_UD_LOW_SPEED__RB_UH_LOW_SPEED_W<'a, const O: u8> =
    crate::BitWriter<'a, u8, R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC, bool, O>;
#[doc = "Field `RB_UD_DM_PIN__RB_UH_DM_PIN` reader - ReadOnly: indicate current UDM pin level"]
pub type RB_UD_DM_PIN__RB_UH_DM_PIN_R = crate::BitReader<bool>;
#[doc = "Field `RB_UD_DP_PIN__RB_UH_DP_PIN` reader - ReadOnly: indicate current UDP pin level"]
pub type RB_UD_DP_PIN__RB_UH_DP_PIN_R = crate::BitReader<bool>;
#[doc = "Field `RB_UD_PD_DIS__RB_UH_PD_DIS` reader - disable USB UDP/UDM pulldown resistance: 0=enable pulldown, 1=disable"]
pub type RB_UD_PD_DIS__RB_UH_PD_DIS_R = crate::BitReader<bool>;
impl R {
    #[doc = "Bit 0 - enable USB physical port I/O: 0=disable, 1=enable;enable USB port: 0=disable, 1=enable port, automatic disabled if USB device detached"]
    #[inline(always)]
    pub fn rb_ud_port_en__rb_uh_port_en(&self) -> RB_UD_PORT_EN__RB_UH_PORT_EN_R {
        RB_UD_PORT_EN__RB_UH_PORT_EN_R::new((self.bits & 1) != 0)
    }
    #[doc = "Bit 1 - general purpose bit;control USB bus reset: 0=normal, 1=force bus reset"]
    #[inline(always)]
    pub fn rb_ud_gp_bit__rb_uh_bus_reset(&self) -> RB_UD_GP_BIT__RB_UH_BUS_RESET_R {
        RB_UD_GP_BIT__RB_UH_BUS_RESET_R::new(((self.bits >> 1) & 1) != 0)
    }
    #[doc = "Bit 2 - enable USB physical port low speed: 0=full speed, 1=low speed;enable USB port low speed: 0=full speed, 1=low speed"]
    #[inline(always)]
    pub fn rb_ud_low_speed__rb_uh_low_speed(&self) -> RB_UD_LOW_SPEED__RB_UH_LOW_SPEED_R {
        RB_UD_LOW_SPEED__RB_UH_LOW_SPEED_R::new(((self.bits >> 2) & 1) != 0)
    }
    #[doc = "Bit 4 - ReadOnly: indicate current UDM pin level"]
    #[inline(always)]
    pub fn rb_ud_dm_pin__rb_uh_dm_pin(&self) -> RB_UD_DM_PIN__RB_UH_DM_PIN_R {
        RB_UD_DM_PIN__RB_UH_DM_PIN_R::new(((self.bits >> 4) & 1) != 0)
    }
    #[doc = "Bit 5 - ReadOnly: indicate current UDP pin level"]
    #[inline(always)]
    pub fn rb_ud_dp_pin__rb_uh_dp_pin(&self) -> RB_UD_DP_PIN__RB_UH_DP_PIN_R {
        RB_UD_DP_PIN__RB_UH_DP_PIN_R::new(((self.bits >> 5) & 1) != 0)
    }
    #[doc = "Bit 7 - disable USB UDP/UDM pulldown resistance: 0=enable pulldown, 1=disable"]
    #[inline(always)]
    pub fn rb_ud_pd_dis__rb_uh_pd_dis(&self) -> RB_UD_PD_DIS__RB_UH_PD_DIS_R {
        RB_UD_PD_DIS__RB_UH_PD_DIS_R::new(((self.bits >> 7) & 1) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - enable USB physical port I/O: 0=disable, 1=enable;enable USB port: 0=disable, 1=enable port, automatic disabled if USB device detached"]
    #[inline(always)]
    #[must_use]
    pub fn rb_ud_port_en__rb_uh_port_en(&mut self) -> RB_UD_PORT_EN__RB_UH_PORT_EN_W<0> {
        RB_UD_PORT_EN__RB_UH_PORT_EN_W::new(self)
    }
    #[doc = "Bit 1 - general purpose bit;control USB bus reset: 0=normal, 1=force bus reset"]
    #[inline(always)]
    #[must_use]
    pub fn rb_ud_gp_bit__rb_uh_bus_reset(&mut self) -> RB_UD_GP_BIT__RB_UH_BUS_RESET_W<1> {
        RB_UD_GP_BIT__RB_UH_BUS_RESET_W::new(self)
    }
    #[doc = "Bit 2 - enable USB physical port low speed: 0=full speed, 1=low speed;enable USB port low speed: 0=full speed, 1=low speed"]
    #[inline(always)]
    #[must_use]
    pub fn rb_ud_low_speed__rb_uh_low_speed(&mut self) -> RB_UD_LOW_SPEED__RB_UH_LOW_SPEED_W<2> {
        RB_UD_LOW_SPEED__RB_UH_LOW_SPEED_W::new(self)
    }
    #[doc = "Writes raw bits to the register."]
    #[inline(always)]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "USB device physical prot control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [r8_udev_ctrl__r8_uhost_ctrl](index.html) module"]
pub struct R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC;
impl crate::RegisterSpec for R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [r8_udev_ctrl__r8_uhost_ctrl::R](R) reader structure"]
impl crate::Readable for R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [r8_udev_ctrl__r8_uhost_ctrl::W](W) writer structure"]
impl crate::Writable for R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC {
    type Writer = W;
    const ZERO_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
    const ONE_TO_MODIFY_FIELDS_BITMAP: Self::Ux = 0;
}
#[doc = "`reset()` method sets R8_UDEV_CTRL__R8_UHOST_CTRL to value 0"]
impl crate::Resettable for R8_UDEV_CTRL__R8_UHOST_CTRL_SPEC {
    const RESET_VALUE: Self::Ux = 0;
}
